#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(10) << fixed;
    char unos;
    int i, j, w, h, r, q, koordx, koordy;
    cin >> w >> h >> r >> q;
    long double x[w + 1], pom;
    for(i = 0; i < w + 1; i++){
        x[i] = h;
    }
    for(i = 0; i < q; i++){
        cin >> unos;
        if(unos == '1'){
            cin >> koordx >> koordy;
            for(j = 0; j < w + 1; j++){
                if(j >= koordx - r && j <= koordx + r){
                    pom = koordy - sqrt(r * r - (koordx - j) * (koordx - j));
                    if(pom < x[j]){
                        x[j] = pom;
                    }
                }
            }
        }
        else{
            cin >> koordx;
            cout << x[koordx] << endl;
        }
    }
    return 0;
}